=== contrib/http-parser/CMakeLists.txt ===
SET(HTTPSRC            http_parser.c)


SET(HTTP_COMPILE_FLAGS "-DRSPAMD_LIB")
IF(ENABLE_FULL_DEBUG MATCHES "OFF")
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
	set(HTTP_COMPILE_FLAGS "${HTTP_COMPILE_FLAGS} -O3")
endif ()
ENDIF()

ADD_LIBRARY(rspamd-http-parser STATIC ${HTTPSRC})
SET_TARGET_PROPERTIES(rspamd-http-parser PROPERTIES VERSION ${RSPAMD_VERSION})
SET_TARGET_PROPERTIES(rspamd-http-parser PROPERTIES COMPILE_FLAGS "${HTTP_COMPILE_FLAGS}")
