=== contrib/linenoise/CMakeLists.txt ===
SET(LINENOISESRC linenoise.c)

ADD_LIBRARY(rspamd-linenoise STATIC ${LINENOISESRC})
SET_TARGET_PROPERTIES(rspamd-linenoise PROPERTIES VERSION ${RSPAMD_VERSION})

IF(ENABLE_FULL_DEBUG MATCHES "OFF")
if ("${CMAKE_C_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
	SET_TARGET_PROPERTIES(rspamd-linenoise PROPERTIES COMPILE_FLAGS "-O3")
endif ()
ENDIF()
