=== debian/changelog ===
rspamd (1.9.4-2build4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:42:11 +0100

rspamd (1.9.4-2build3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 09:41:58 +0100

rspamd (1.9.4-2build2) focal; urgency=medium

  * No-change rebuild for libevent soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 19 Oct 2019 19:58:31 +0000

rspamd (1.9.4-2build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 11:08:23 +0000

rspamd (1.9.4-2) unstable; urgency=medium

  [ Sergio Durigan Junior ]
  * d/{control,rules}: Enable build with hyperscan (amd64 only), and add
    myself to Uploaders.

 -- Sebastien Badia <sbadia@debian.org>  Tue, 09 Jul 2019 12:10:41 +0200

rspamd (1.9.4-1) experimental; urgency=medium

  [ Jerome Lebleu ]
  * New upstream version 1.9.4 (Closes: #929134)
  * d/control: Use shipped version of D3.js instead of libjs-d3
    (Closes: #918027)
  * d/missing-sources: Add jQuery Sticky Tabs source

  [ Sebastien Badia ]
  d/control: Bump to Standards-Version 4.3.0 (no changes needed)

 -- Sebastien Badia <sbadia@debian.org>  Thu, 30 May 2019 19:20:23 +0200

rspamd (1.9.0-1) experimental; urgency=medium

  * New upstream version 1.9.0
  * d/rules: Slashing: Distinguish lualibdir, pluginsdir and sharedir
  * d/logrotate: Fix log rotation if SystemD is used (Closes: #919789)
                 Thanks Alexandre !
  * d/tests: Ugly-patch for flaky tests… (Closes: #914477)
  * d/copyright: Added Jerome and I on debian/*

 -- Sebastien Badia <sbadia@debian.org>  Mon, 01 Apr 2019 00:32:39 +0200
